<template lang="html">
  <div class="butter-prompt">
    <div class="content">
      <span class="title" v-if="title">{{ title }}</span>
      <p v-if="message" v-html="message"></p>
      <div class="actions" v-if="actions.length">
        <butter-button v-for="(action, i) in actions" :key="i" :theme="action.style"  @click.self="handler(action)">{{ action.title }}</butter-button>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    'title': {
      type: String,
    },
    'message': {
      type: String,
    },
    'userActions': {
      type: Array,
      default: _ => ([]),
    },
  },
  data() {
    return {
      actions: this.userActions,
    };
  },
  methods: {
    handler(action) {
      this.$emit('action', action);
    },
  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';
.butter-prompt {
  @include absolute-full;
  z-index: 9;
  width: 80vw;
  height: 80vh;
  margin: auto;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
}
.content {
  @include themify($themes) {
    background: themed('color-bg-secondary');
    border: themed('border');
  }
  display: flex;
  flex-direction: column;
}
.title {
  // Background & borders
  // Mixins
  @include themify($themes) {
    background: themed('color-bg-primary');
    color: themed('color-text-primary');
  }
  @include box-sizing;
  // Box properties
  margin: 0 0;
  padding: $grid * 2;
  display: inline-block;
  width: 100%;
  // Typography
  font-family: $font-sans-bold;
  // Animation
  // Other
}
p {
  // Mixins
  // Box properties
  margin: ($grid * 2) $grid;
  // Background & borders
  // Typography
  // Animation
  // Other
}
.actions {
  display: flex;
  padding: $grid;

  text-align: center;
  border-top: 0;

  > div {
    margin: 0 $grid;
    flex-basis: 50%;
  }
}
</style>
